package test.artifact;

import java.io.IOException;

import net.openhft.chronicle.ExcerptAppender;
import net.openhft.chronicle.ExcerptTailer;
import net.openhft.chronicle.IndexedChronicle;

public class P1 {
	private IndexedChronicle _chronicle1;
	private IndexedChronicle _chronicle5;
	private ExcerptAppender _appender1;
	private ExcerptTailer _tailer5;
    private StringBuilder _string;

	public P1 () {}

	public void start() throws IOException {
    	_chronicle1 = new IndexedChronicle("../chr/h1/chr1");
    	_appender1 = _chronicle1.createAppender();
    	_appender1.toEnd();
    	_chronicle5 = new IndexedChronicle("../chr/h1/chr5");
    	_tailer5 = _chronicle5.createTailer();
    	_tailer5.toEnd();
    	_string = new StringBuilder();
    	_string.append("foo bar");

    	sendReceiveLoop();
	}

	private void sendReceiveLoop() {
    	final Msg msg = new Msg();
        int orders = 10;
        for (int i = 0; i < orders; i++) {
        	msg._longField = 1000+i;
        	((StringBuilder)(msg._stringField)).delete(0, 1000);
        	((StringBuilder)(msg._stringField)).append(_string);
        	msg._intField = i;
        	msg.write(_appender1);
         	System.out.println("    sent "+msg);

			do { // busy loop
				if (_tailer5.nextIndex()) {
					msg.read(_tailer5);
					System.out.println(" received "+msg);
					break;
				}
			} while (true);
        }
	}

	public static void main(String[] args) throws IOException {
		P1 p = new P1();
		p.start();
	}
}
